'use strict';

var _confirm = require('../confirm');

var _confirm2 = _interopRequireDefault(_confirm);

var _store = require('../store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test.only('it should call actions.open', function () {
  var spy = jest.spyOn(_store.actions, 'open');
  (0, _confirm2.default)('hey');

  var arg = spy.mock.calls[0][1];
  expect(arg).toEqual('hey');

  spy.mockReset();
  spy.mockRestore();
});

test.only('it should return actions.open', function () {
  var spy = jest.spyOn(_store.actions, 'open').mockReturnValue(Promise.resolve());
  expect((0, _confirm2.default)('hey').then).not.toEqual(null);
});