'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reader = require('./reader');

var _reader2 = _interopRequireDefault(_reader);

var _Droppable = require('./Droppable');

var _Droppable2 = _interopRequireDefault(_Droppable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactUploadi = function (_React$Component) {
  _inherits(ReactUploadi, _React$Component);

  function ReactUploadi() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ReactUploadi);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ReactUploadi.__proto__ || Object.getPrototypeOf(ReactUploadi)).call.apply(_ref, [this].concat(args))), _this), _this.file = null, _this.handleDrop = function (files) {
      _this.process(files);
    }, _this.handleSelect = function (evt) {
      _this.process(Array.from(evt.target.files));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ReactUploadi, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        _Droppable2.default,
        { onDrop: this.handleDrop },
        function (_ref2) {
          var over = _ref2.over;
          return _react2.default.createElement(
            'div',
            null,
            _this2.props.children({
              over: over,
              onSelect: function onSelect() {
                return _this2.file.click();
              }
            }),
            _react2.default.createElement('input', { type: 'file',
              multiple: _this2.props.multiple,
              style: { display: 'none' },
              ref: function ref(c) {
                return _this2.file = c;
              },
              onChange: _this2.handleSelect })
          );
        }
      );
    }
  }, {
    key: 'process',
    value: function process(files) {
      var _this3 = this;

      Promise.all(files.map(function (file) {
        return (0, _reader2.default)(file);
      })).then(function (evts) {
        var results = evts.map(function (evt) {
          return evt.target.result;
        });
        if (_this3.props.multiple) {
          _this3.props.onFiles(files, results);
        } else {
          _this3.props.onFiles(files[0], results[0]);
        }
        _this3.file.value = null;
      });
    }
  }]);

  return ReactUploadi;
}(_react2.default.Component);

ReactUploadi.propTypes = {
  multiple: _propTypes2.default.bool,
  accept: _propTypes2.default.string,
  onFiles: _propTypes2.default.func.isRequired
};

ReactUploadi.defaultProps = {
  multiple: false
};

exports.default = ReactUploadi;