"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = omit;
/**
 * Generate a new array without the provided keys.
 * Bare minimum implementation of `omit`.
 * @param {<mixed>} arr
 * @param {<String>} keys
 */
function omit(arr, keys) {
  var result = {};

  for (var key in arr) {
    if (!~keys.indexOf(key)) {
      result[key] = arr[key];
    }
  }

  return result;
}