'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react3 = require('./unistore/react');

var _store = require('./store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseConfirmRoot = (0, _react3.connect)(function (state) {
  return state;
}, _store.actions)(function (_ref) {
  var active = _ref.active,
      text = _ref.text,
      options = _ref.options,
      proceed = _ref.proceed,
      dismiss = _ref.dismiss,
      children = _ref.children;
  return children({
    active: active,
    text: text,
    options: options,
    actions: { proceed: proceed, dismiss: dismiss }
  });
});

var instance = null;

var ConfirmRoot = function (_Component) {
  _inherits(ConfirmRoot, _Component);

  function ConfirmRoot() {
    _classCallCheck(this, ConfirmRoot);

    return _possibleConstructorReturn(this, (ConfirmRoot.__proto__ || Object.getPrototypeOf(ConfirmRoot)).apply(this, arguments));
  }

  _createClass(ConfirmRoot, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (instance) {
        throw new Error('Only a single ConfirmRoot can be mounted at a time.');
      }

      instance = this;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      instance = null;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _react3.Provider,
        { store: _store.store },
        _react2.default.createElement(
          BaseConfirmRoot,
          null,
          this.props.children
        )
      );
    }
  }]);

  return ConfirmRoot;
}(_react.Component);

ConfirmRoot.propTypes = {
  children: _propTypes2.default.func
};

exports.default = ConfirmRoot;