'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDnd = require('react-dnd');

var _reactDndHtml5Backend = require('react-dnd-html5-backend');

var _reactDndHtml5Backend2 = _interopRequireDefault(_reactDndHtml5Backend);

var _compose = require('./compose');

var _compose2 = _interopRequireDefault(_compose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Droppable = function (_React$Component) {
  _inherits(Droppable, _React$Component);

  function Droppable() {
    _classCallCheck(this, Droppable);

    return _possibleConstructorReturn(this, (Droppable.__proto__ || Object.getPrototypeOf(Droppable)).apply(this, arguments));
  }

  _createClass(Droppable, [{
    key: 'render',
    value: function render() {
      return this.props.target(this.props.children({ over: this.props.over }));
    }
  }]);

  return Droppable;
}(_react2.default.Component);

Droppable.propTypes = {
  onDrop: _propTypes2.default.func
};

exports.default = (0, _compose2.default)((0, _reactDnd.DragDropContext)(_reactDndHtml5Backend2.default), (0, _reactDnd.DropTarget)(function () {
  return [_reactDndHtml5Backend.NativeTypes.FILE];
}, {
  drop: function drop(item, monitor, _ref) {
    var props = _ref.props;

    props.onDrop(monitor.getItem().files);
  }
}, function (connect, monitor) {
  return {
    target: connect.dropTarget(),
    over: monitor.isOver()
  };
}))(Droppable);